package com.ejie.ab79.service.preguntasRespuestas;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.dao.preguntasRespuestas.FicherosAdjProDao;
import com.ejie.ab79.model.REST.servicioWeb.FicheroRespuestaProtocolo;
import com.ejie.ab79.model.preguntasRespuestas.FicherosAdjPro;
import com.ejie.ab79.webservice.adaptadores.PIFAdaptador;
import com.ejie.ab79.webservice.adaptadores.ab61WebServiceAdaptador;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * FicherosAdjProServiceImpl  
 * 
 *  
 */

@Service(value = "ficherosAdjProService")
public class FicherosAdjProServiceImpl implements FicherosAdjProService {

	private static final Logger logger = LoggerFactory.getLogger(FicherosAdjProServiceImpl.class);

	@Autowired
	private FicherosAdjProDao ficherosAdjProDao;

	@Autowired
	private ab61WebServiceAdaptador ab61WebServiceAdaptadorService;

	@Autowired
	private PIFAdaptador pifAdapterService;

	/**
	 * Inserts a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosAdjPro
	 *            FicherosAdjPro
	 * @return FicherosAdjPro
	 */
	@Transactional(rollbackFor = Throwable.class)
	public FicherosAdjPro add(FicherosAdjPro ficherosAdjPro) {
		return this.ficherosAdjProDao.add(ficherosAdjPro);
	}

	/**
	 * Updates a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosAdjPro
	 *            FicherosAdjPro
	 * @return FicherosAdjPro
	 */
	@Transactional(rollbackFor = Throwable.class)
	public FicherosAdjPro update(FicherosAdjPro ficherosAdjPro) {
		return this.ficherosAdjProDao.update(ficherosAdjPro);
	}

	/**
	 * Finds a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosAdjPro
	 *            FicherosAdjPro
	 * @return FicherosAdjPro
	 */
	public FicherosAdjPro find(FicherosAdjPro ficherosAdjPro) {
		return (FicherosAdjPro) this.ficherosAdjProDao.find(ficherosAdjPro);
	}

	/**
	 * Deletes a single row in the FicherosAdjPro table.
	 *
	 * @param ficherosAdjPro
	 *            FicherosAdjPro
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(FicherosAdjPro ficherosAdjPro) {
		this.ficherosAdjProDao.remove(ficherosAdjPro);
	}

	/**
	 * Finds a list of rows in the FicherosAdjPro table.
	 *
	 * @param ficherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<FicherosAdjPro>
	 */
	public List<FicherosAdjPro> findAll(FicherosAdjPro ficherosAdjPro, TableRequestDto tableRequestDto) {
		return (List<FicherosAdjPro>) this.ficherosAdjProDao.findAll(ficherosAdjPro, tableRequestDto);
	}

	/**
	 * Finds rows in the FicherosAdjPro table using like.
	 *
	 * @param ficherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<FicherosAdjPro>
	 */
	public List<FicherosAdjPro> findAllLike(FicherosAdjPro ficherosAdjPro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<FicherosAdjPro>) this.ficherosAdjProDao.findAllLike(ficherosAdjPro, tableRequestDto, startsWith);
	}

	@Override
	public List<FicheroRespuestaProtocolo> findFicherosREST(Integer idInspeccion) {
		return (List<FicheroRespuestaProtocolo>) this.ficherosAdjProDao.findFicherosREST(idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the FicherosAdjPro table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(FicherosAdjPro filterFicherosAdjPro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		this.ficherosAdjProDao.removeMultiple(filterFicherosAdjPro, tableRequestDto, startsWith);
	}

	/**
	 * Filter method in the FicherosAdjPro table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<FicherosAdjPro>
	 */
	public TableResponseDto<FicherosAdjPro> filter(FicherosAdjPro filterFicherosAdjPro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<FicherosAdjPro> listaFicherosAdjPro = this.ficherosAdjProDao.findAllLike(filterFicherosAdjPro,
				tableRequestDto, false);
		Long recordNum = this.ficherosAdjProDao
				.findAllLikeCount(filterFicherosAdjPro != null ? filterFicherosAdjPro : new FicherosAdjPro(), false);

		TableResponseDto<FicherosAdjPro> usuarioDto = new TableResponseDto<FicherosAdjPro>(tableRequestDto, recordNum,
				listaFicherosAdjPro);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<FicherosAdjPro>> reorderSelection = this.ficherosAdjProDao
					.reorderSelection(filterFicherosAdjPro, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<FicherosAdjPro>> reorderSeeker = this.ficherosAdjProDao
					.reorderSelection(filterFicherosAdjPro, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;
	}

	/**
	 * Searches rows in the FicherosAdjPro table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param searchFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosAdjPro>>
	 */
	public List<TableRowDto<FicherosAdjPro>> search(FicherosAdjPro filterFicherosAdjPro,
			FicherosAdjPro searchFicherosAdjPro, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.ficherosAdjProDao.search(filterFicherosAdjPro, searchFicherosAdjPro, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in FicherosAdjPro table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(FicherosAdjPro filterFicherosAdjPro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.ficherosAdjProDao.reorderSelection(filterFicherosAdjPro, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the FicherosAdjPro table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<JerarquiaDto<FicherosAdjPro>>
	 */
	public TableResponseDto<JerarquiaDto<FicherosAdjPro>> jerarquia(FicherosAdjPro filterFicherosAdjPro,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<FicherosAdjPro>> listaFicherosAdjPro = this.ficherosAdjProDao
				.findAllLikeJerarquia(filterFicherosAdjPro, tableRequestDto);
		Long recordNum = this.ficherosAdjProDao.findAllLikeCountJerarquia(filterFicherosAdjPro, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<FicherosAdjPro>>(tableRequestDto, recordNum, listaFicherosAdjPro);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the FicherosAdjPro
	 * table.
	 *
	 * @param filterFicherosAdjPro
	 *            FicherosAdjPro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<FicherosAdjPro>>
	 */
	public TableResponseDto<JerarquiaDto<FicherosAdjPro>> jerarquiaChildren(FicherosAdjPro filterFicherosAdjPro,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<FicherosAdjPro>> tableResponseDto = new TableResponseDto<JerarquiaDto<FicherosAdjPro>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.ficherosAdjProDao.findAllChild(filterFicherosAdjPro, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<FicherosAdjPro> getMultiple(FicherosAdjPro filterFicherosAdjPro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.ficherosAdjProDao.getMultiple(filterFicherosAdjPro, tableRequestDto, startsWith);
	}

	/**
	 * Descarga el fichero seleccionado en la pestaña informe técnico
	 */
	public void descargaFicheros(Integer idFichero, HttpServletResponse response) throws IOException {

		FicherosAdjPro ficherosAdjPro = new FicherosAdjPro();
		ficherosAdjPro.setIdFicherosAdjPro(idFichero);

		FicherosAdjPro fichero = this.ficherosAdjProDao.find(ficherosAdjPro);
		BufferedInputStream bIS = null;

		try {
			String pathPif = this.ab61WebServiceAdaptadorService.descargarDocumentoPid(fichero.getOidPid(),
					Constantes.CODIGO_APLICACION, Constantes.TIPO_URL_PARCIAL);

			if (!StringUtils.isEmpty(pathPif)) {
				response.setHeader("content-disposition",
						"attachment; filename=\"" + fichero.getNombreFicheroAdjunto() + "\"");
				bIS = new BufferedInputStream(this.pifAdapterService.getFile(pathPif));
				IOUtils.copy(bIS, response.getOutputStream());
				response.flushBuffer();
			}
			FicherosAdjProServiceImpl.logger.debug("descargarDocumentoPid:" + pathPif);

		} catch (Exception e) {
			FicherosAdjProServiceImpl.logger.error("descargarDocumentoPid - ERROR " + e.getMessage(), e);
		} finally {
			if (bIS != null) {
				bIS.close();
			}
		}

	}

	@Override
	public List<FicherosAdjPro> findFicherosByIdRespuesta(Integer idRespuesta) {
		return this.ficherosAdjProDao.findFicherosByIdRespuesta(idRespuesta);
	}

}
